<?php
if (file_exists('src/config/credentials.php')) {
    require_once('src/config/credentials.php');
    if (isset($credentials['username'])) {
        echo 'Hey! It looks like you already installed backlink monitoring software now! Blimey isnt it? Would you like to reinstall? Then remove or clear this file -- <b>src/config/credentials.php </b> and try to reinstall. If not, then please remove <b>install.php</b> file from root for security reasons. <br/><br/> We wish you good luck with your SEO Success.';
        exit;
    }
}
$errors = array();
$success = false;

$username = $password  = $mysqlUser = $mysqlPassword = $mysqlDatabase = '';
$mysqlHost = 'localhost';


$configs = array(
    'credentials' => 'src/config/credentials.php',
    'db' => 'src/config/db.php'
);
foreach ($configs as $config) {
    if (!is_writeable($config)) {
        $errors[] = 'Please set writeable permissions(0777) for '.$config;
    }
}


if ($_POST && !$errors) {
    $username = $_POST['username'];
    $password = trim($_POST['password']);
    $mysqlHost = $_POST['mysql_host'];
    $mysqlUser = $_POST['mysql_user'];
    $mysqlPassword = $_POST['mysql_password'];
    $mysqlDatabase = $_POST['mysql_database'];

    if (!preg_match("/^[1-9a-zA-Z'-]{2,256}$/",$username)) {
        $errors[] = 'Invalid username. It must be letters or digits 3-100 length.';
    }

    if (strlen($password) < 5) {
        $errors[] = 'Password must be not less than 5 symbols length';
    }

    if (!$mysqlDatabase || !$mysqlHost || !$mysqlUser) {
        $errors[] = 'Please complite mysql settings';
    }

    if (!$errors) {
        try {
            require  'vendor/redbean/rb.php';
            \R::setup('mysql:host=' . $mysqlHost . ';dbname=' . $mysqlDatabase, $mysqlUser, $mysqlPassword);
            \R::$f->now();

            $templine = '';
            // Read in entire file
            $lines = file('src/sql/backlinks.sql');
            // Loop through each line
            foreach ($lines as $line)
            {
                // Skip it if it's a comment
                if (substr($line, 0, 2) == '--' || $line == '')
                    continue;

                // Add this line to the current segment
                $templine .= $line;
                // If it has a semicolon at the end, it's the end of the query
                if (substr(trim($line), -1, 1) == ';')
                {
                    // Perform the query
                    \R::exec($templine);
                    // Reset temp variable to empty
                    $templine = '';
                }
            }

        }
        catch (Exception $e) {
            echo $e->getMessage();exit;
            $errors[] = 'Could not connect to database and to create tables. Please check mysql settings.';
        }

        if (!$errors) {
            $databaseConfig = "<?php\n
            if (!defined('APP_PATH')){exit;}\n
            \$db = array(
                'host' => '$mysqlHost',\n
                'user' => '$mysqlUser',\n
                'password' => '$mysqlPassword',\n
                'db' => '$mysqlDatabase'\n
            );";


            file_put_contents($configs['db'], $databaseConfig);

            $credentialsConfig = "<?php\n
            \$credentials = array(\n
            'username' => '".$username."',\n
            'password' => '".md5($password)."'\n
            );";

            file_put_contents($configs['credentials'], $credentialsConfig);


            $dirname = dirname($_SERVER['REQUEST_URI']);
            if ($dirname != '/') {
                $dirname = '/'.$dirname;
            }

            $success  = true;
        }
    }

}



?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <title>Install - Backlinks monitor</title>

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
    <meta name="apple-mobile-web-app-capable" content="yes">

    <link href="css/bootstrap.min.css" rel="stylesheet" type="text/css"/>
    <link href="css/bootstrap-responsive.min.css" rel="stylesheet" type="text/css"/>

    <link href="css/font-awesome.css" rel="stylesheet">
    <link href="http://fonts.googleapis.com/css?family=Open+Sans:400italic,600italic,400,600" rel="stylesheet">

    <link href="css/style.css" rel="stylesheet" type="text/css">
    <link href="css/pages/signin.css" rel="stylesheet" type="text/css">

</head>

<body>

<div class="navbar navbar-fixed-top">

    <div class="navbar-inner">

        <div class="container">

            <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </a>

            <a class="brand" href="">
                Backlinks Monitor Install
            </a>

            <div class="nav-collapse">

            </div>
            <!--/.nav-collapse -->

        </div>
        <!-- /container -->

    </div>
    <!-- /navbar-inner -->

</div>
<!-- /navbar -->
<div class="subnavbar"></div>

<div class="main">

<div class="main-inner">

<div class="container">

<div class="row">

<div class="span12">

<div class="widget ">

<div class="widget-header">
    <i class="icon-user"></i>

    <h3>Install Data - Please Submit Database and User Info</h3>
</div>
<!-- /widget-header -->

<div class="widget-content">

    <div id="formcontrols" class="tab-pane active">
        <?php if ($errors):?>
            <div class="alert alert-error">
                <?php foreach ($errors as $error):?>
                <b><?php echo $error?></b><br/>
                <?php endforeach;?>
            </div>
        <?php endif;?>
        <?php if($success):?>
            <h2>Congratulation! Backlinks Monitor Software Has Been Successfully Installed.</h2><br/>
            Please use following information to login to your account. Please also save this information for future reference.<br/><br/>
            Username: <b><?php echo $username?></b><br/>
            Password: <b><?php echo $password?></b>
            <br/><br/>
            For security reasons, we strongly suggest you to remove <b>install.php</b> file from root.
        <?php else:?>
            <form class="form-horizontal" id="edit-profile" method="post">
            <fieldset>

                <div class="control-group">
                    <label for="username" class="control-label">Username</label>

                    <div class="controls">
                        <input type="text" name="username" id="username" class="span4" value = "<?php echo htmlspecialchars($username)?>">
                    </div>
                    <!-- /controls -->
                </div>
                <!-- /control-group -->

                <div class="control-group">
                    <label for="password1" class="control-label">Password</label>

                    <div class="controls">
                        <input type="text" id="password1" name = "password" class="span4" value="<?php echo htmlspecialchars($password)?>">
                    </div>
                    <!-- /controls -->
                </div>
                <!-- /control-group -->

                <br><br>


                <div class="control-group">
                    <label for="email" class="control-label">Mysql host</label>

                    <div class="controls">
                        <input type="text" value="<?php echo htmlspecialchars($mysqlHost)?>" id="host" name = "mysql_host" class="span4">
                    </div>
                    <!-- /controls -->
                </div>
                <div class="control-group">
                    <label for="email" class="control-label">Mysql User</label>

                    <div class="controls">
                        <input type="text" value="<?php echo htmlspecialchars($mysqlUser)?>" id="mysql_user" name = "mysql_user" class="span4">
                    </div>
                    <!-- /controls -->
                </div>


                <div class="control-group">
                    <label for="email" class="control-label">Mysql Password</label>

                    <div class="controls">
                        <input type="text" value="<?php echo htmlspecialchars($mysqlPassword)?>" id="mysql_password" name = "mysql_password" class="span4">
                    </div>
                    <!-- /controls -->
                </div>

                <div class="control-group">
                    <label for="email" class="control-label">Mysql Database</label>

                    <div class="controls">
                        <input type="text" value="<?php echo htmlspecialchars($mysqlDatabase)?>" id="mysql_database" name = "mysql_database" class="span4">
                    </div>
                    <!-- /controls -->
                </div>

                <!-- /control-group -->

                <br>


                <div class="form-actions">
                    <button class="btn btn-primary" type="submit">Install Now!</button>
                </div>
                <!-- /form-actions -->
            </fieldset>
        </form>
        <?php endif;?>
    </div>


</div>
<!-- /widget-content -->

</div>
<!-- /widget -->

</div>
<!-- /span8 -->


</div>
<!-- /row -->

</div>
<!-- /container -->

</div>
<!-- /main-inner -->

</div>
<script src="js/jquery-1.7.2.min.js"></script>
<script src="js/bootstrap.js"></script>

<script src="js/signin.js"></script>

</body>

</html>